Additional tweaks
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=2.0
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # Package Dependencies (apt-get install these for example):
19 # lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
20 #
21 # Specific Executable (program) Dependencies (must be found in $PATH):
22 # volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs HandBrakeCLI
23 #
24 # Optional Dependencies:
25 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
26 #
27
28 ##############################################################################################
29 # Global Variables
30 ##############################################################################################
31 typeset cmd="$0 $*"
32 typeset dvdname=""
33 typeset debug=""
34 typeset dest=""
35 typeset isofile=""
36 typeset vobfile=""
37 typeset dvdpath=""
38 typeset aspect=""
39 typeset SCALE=""
40 typeset CROP=""
41 typeset profile="xvidhq"
42 typeset extension=""
43 typeset mailto=""
44 typeset encoder=""
45 typeset default_alang="en"
46 typeset track=""
47 typeset -i default_aid=128
48 typeset -i aid_override=-1
49 typeset -i force_onepass_mode=0
50 typeset -i eject_disk=1
51 typeset -i keep_isofile=0
52 typeset -i keep_vobfile=0
53 typeset -i keep_dvdfolder=0
54 typeset -i keep_intermediate_files=0
55 typeset -i make_final_dest_vob=0
56 typeset -i make_final_dest_iso=0
57 typeset -i make_final_dest_folder=0
58 typeset -i make_final_dest_comp=0
59 typeset -i errors=0
60 typeset -i show_usage=0
61 typeset -i mirror_mode=0
62 typeset -i target_bitrate=2000
63 typeset -i target_size=0
64 typeset -i audio_2ch=0
65 typeset -i audio_6ch=1
66 typeset -i invalid_feature_title=0
67 typeset -i feature_title_override=0
68 typeset -i mplayer_dumpstream_incompatibility=0
69
70 ##############################################################################
71 # Local Machine Settings:
72 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
73 # and the local conf file created by each local machine (rip_dvd.conf)
74 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
75 # This will allow you to override all the default values to meet your needs
76 # in a way that won't get clobbered when you pull updates from my GIT repo.
77 ##############################################################################
78 config="${0%/*}/rip_dvd.conf"
79
80 # The config file will be searched for in the following location order:
81 found_config=0
82
83 # 1) /path/to/rip_dvd/script/rip_dvd.conf.dist
84 [ -e "${config}.dist" ] && found_config=1 && . "${config}.dist"
85
86 # 2) /path/to/rip_dvd/script/rip_dvd.conf
87 [ -e "${config}" ] && found_config=1 && . "${config}"
88
89 # 3) /etc/rip_dvd.conf
90 [ -e "/etc/rip_dvd.conf" ] && found_config=1 && . "/etc/rip_dvd.conf"
91
92 # 4) $PWD/rip_dvd.conf
93 [ -e "$PWD/rip_dvd.conf" ] && found_config=1 && . "$PWD/rip_dvd.conf"
94
95 # Check to make sure we found the config file
96 if [ $found_config -eq 0 ]; then
97   echo "-E- Unable to find the rip_dvd.conf file: $config"
98   exit 1
99 fi
100
101 ##############################################################################################
102 # Command line processing
103 ##############################################################################################
104 while (($#)) && getopts 162wmvifkzx:ht:n:d:b:s:t:a:p:e:j:l: opt "$@"
105 do
106     case $opt in
107         (n)     dvdname=$OPTARG;;
108         (d)     dest=$OPTARG;;
109         (b)     target_bitrate=$OPTARG;;
110         (s)     target_size=$OPTARG;;
111         (2)     audio_2ch=1;;
112         (6)     audio_6ch=1;;
113         (1)     force_onepass_mode=1;;
114         (v)     make_final_dest_vob=1;;
115         (i)     make_final_dest_iso=1;;
116         (f)     make_final_dest_folder=1;; 
117         (z)     make_final_dest_comp=1;;
118         (e)     encoder=$OPTARG;;
119         (m)     mirror_mode=1;;
120         (k)     keep_intermediate_files=1;;
121         (t)     feature_title_override=$OPTARG;;
122         (a)     aspect=$OPTARG;;
123         (p)     profile=$OPTARG;;
124         (x)     extension=$OPTARG;;
125         (j)     eject_disk=$OPTARG;;
126         (l)     aid_override=$OPTARG;;
127         (w)     set -x;;
128         (h)     show_usage=1;;
129         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
130         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
131     esac
132 done
133
134 shift $((OPTIND-1))
135
136 function usage() {
137     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
138     echo >&2 "Revision $REV"
139     echo >&2 "Options:"
140     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
141     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
142     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
143     echo >&2 "                 2) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
144     echo >&2 "                 3) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
145     echo >&2 "                 4) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
146     echo >&2 "                 5) If dvdname is a full path to a VOB file, it will be ripped as a DVD instead of $dev"
147     echo >&2 "   -p <profile>  Specify which encoding profile to use in -x mode as shown below:"
148     echo >&2 "                 Mencoder and Handbrake Encoder Profiles:"
149     echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding"
150     echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding (default)"
151     echo >&2 "                 - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
152     echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
153     echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
154     echo >&2 "                 Handbrake Only Encoder Profiles:"
155     echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
156     echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
157     echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
158     echo >&2 "                 - hb_<profile> = Any predefined HandBrake profile"
159     echo >&2 "   -x <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
160     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
161     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
162     echo >&2 "                 The default operation is non-mirror mode where only the main"
163     echo >&2 "                 feature title will be ripped."
164     echo >&2 "   -v            Make the final image a DVD VOB file"
165     echo >&2 "   -i            Make the final image a DVD ISO file"
166     echo >&2 "   -f            Make the final image a DVD folder"
167     echo >&2 "   -z            Make the final image a compressed file based on your profile selection and encoder"
168     echo >&2 "   -e <encoder>  Specify the encoder to use to make the compressed file (valid encoders=mencoder|handbrake) (default=handbrake if found)"
169     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options with xvid profiles"
170     echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
171     echo >&2 "   -b <bitrate>  Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
172     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
173     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
174     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
175     echo >&2 "   -j <n>        Eject the disk:"
176     echo >&2 "                 - 0 = do not eject the disk"
177     echo >&2 "                 - 1 = eject after the entire script is done (default)"
178     echo >&2 "                 - 2 = eject after the disk is no longer needed (prior to starting the encode process)"
179     echo >&2 "                 The last option will allow you to start ripping another disk while the encoding process is running on a previous"
180     echo >&2 "   -1            Force 1-pass encoding mode across all profiles"
181     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
182     echo >&2 "   -6            Use 6 channel AC3 audio encoding when making a compressed file (default)"
183     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
184     echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
185     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
186     echo >&2 "   -l <aid>      Specify the audio AID language ID to rip from the source DVD"
187     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
188     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
189     echo >&2 ""
190     exit 2
191 }
192
193 if (($errors)) || (($show_usage))
194 then
195   usage
196 fi
197
198 # Sanity Check - Command Line Options 
199 if [ "$dest" == "" ]; then
200   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
201   usage
202 fi
203
204 if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
205   echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
206   usage
207 fi
208
209 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
210   echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
211   usage
212 fi
213
214 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
215    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
216   echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-z'" | tee -a $logfile
217   usage
218 fi
219
220 if [ $mirror_mode -eq 1 ]; then
221   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
222      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
223     echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
224     usage
225   fi
226 fi
227
228 # Make handbrake the default encoder if not specified and we can find it
229 if [ -z "$encoder" ]; then
230   encoder="mencoder"; # If we can't find handbrake, set mencoder as the default
231   [[ -x `which $handbrake_xvid` ]] && [[ "$profile" =~ "xvid" ]] && encoder="handbrake";
232   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "mp4" ]] && encoder="handbrake";
233   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "ip" ]] && encoder="handbrake";
234   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "hb" ]] && encoder="handbrake";
235 fi
236
237 # Sanity check the profile selection
238 if [[ "$encoder" == "mencoder" ]]; then
239   [[ "$profile" =~ "mp4" ]] && echo "-E- invalid encoder $encoder selected for mp4 profile: $profile" && exit
240 fi
241
242 if [[ "$encoder" != "mencoder" ]] && [[ "$encoder" != "handbrake" ]]; then
243   echo "-E- Invalid encoder specified: $encoder"
244   exit 1
245 fi
246
247 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
248 if [ "$aspect" != "" ]; then
249   echo "$aspect" | grep -q "x"
250   if [ $? == 0 ]; then
251     echo "-E- You must specify the aspect option with a value whose format is W:H"
252     exit 1
253   fi
254   echo "$aspect" | grep -q ":"
255   if [ $? != 0 ]; then
256     SCALE=",scale -zoom -sws 9 -xy $aspect"
257   else
258     SCALE=",scale=$aspect"
259   fi
260 fi
261
262 # Sanity Check - Key executables
263 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
264 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
265 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
266 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
267 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
268 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
269 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
270 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
271 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing encoder: $handbrake_xvid" && exit
272 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
273 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "ip" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
274 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "hb" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
275 [[ "$encoder" == "handbrake" ]] && [[ ! -x `which ffmpeg` ]] && echo "-E- missing dependency: ffmpeg" && exit
276
277 ##############################################################################################
278
279 typeset -i ripdvd
280 if [ -z "$dvdname" ]; then
281
282   # make sure the DVD device is accessible
283   volname $dev > /dev/null 2>&1
284   if [ $? != 0 ]; then
285     echo "-E- Can't access the DVD device $dev"
286     exit 1
287   fi
288   # now capture the volume name from the device
289   dvdname=`volname $dev | awk '{ print $1 }'`
290   ripdvd=1
291
292 else 
293
294   # check to see if dvdname is a full path to a real directory
295   # if it is, set dvdname and dvdpath appropriately
296   if [ -d "$dvdname" ]; then
297     dvdpath="$dvdname"
298     dvdname=`basename "$dvdname"`
299     keep_dvdfolder=1
300     if [ -z "$dvdname" ]; then
301      echo "-E- Unable to extract dvdname from path: $dvdpath"
302      exit 1
303     fi
304     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
305       echo "-E- You must supply a full path to a valid DVD folder with this option"
306       exit 1
307     fi
308   fi
309
310   # Check to see if dvdname is a full path to a file
311   if [ -f "$dvdname" ]; then
312     valid_file=0
313
314     # check to see if dvdname is a full path to an MPG2 (VOB) file
315     # if it is, set dvdname and vobfile appropriately
316     file "$dvdname" | grep -q "MPEG"
317     if [ $? == 0 ]; then
318       # It is a valid MPEG2 file, now strip the extension off our dvdname
319       vobfile="$dvdname"
320       dvdname=`basename "$dvdname"`
321       dvdname=${dvdname%.[^.]*}
322       keep_vobfile=1
323       valid_file=1
324     fi
325
326     # check to see if dvdname is a full path to an ISO file
327     # if it is, set dvdname and isofile appropriately
328     file "$dvdname" | grep -q -e "ISO" -e "UDF"
329     if [ $? == 0 ]; then
330       # It is a valid ISO file, now strip the extension off our dvdname
331       isofile="$dvdname"
332       dvdname=`basename "$dvdname"`
333       dvdname=${dvdname%.[^.]*}
334       keep_isofile=1
335       valid_file=1
336     fi    
337
338     # check to see if dvdname is a full path to an ISO file
339     # if it is, set dvdname and isofile appropriately
340     file "$dvdname" | grep -q -e "VOB"
341     if [ $? == 0 ]; then
342       # It is a valid VOB file, now strip the extension off our dvdname
343       vobfile="$dvdname"
344       dvdname=`basename "$dvdname"`
345       dvdname=${dvdname%.[^.]*}
346       keep_vobfile=1
347       valid_file=1
348     fi    
349
350     # If we didn't find a handler for the file above, complain
351     if [ $valid_file -eq 0 ]; then
352       echo "-E- Unsupported file type: $vobfile"
353       exit 1
354     fi
355
356   # Throw an error if we can't find what the -n option is pointing to
357   else 
358     echo "-E- Unable to find the directory or file specified by the '-n $dvdname' option. Please make sure the path is valid."
359     exit 1
360   fi
361
362   # Set the ripdvd flag to false since we aren't ripping a DVD disk
363   ripdvd=0
364
365   # Since we aren't ripping a DVD disk, don't eject anything either
366   eject_disk=0
367
368 fi
369
370 # remove bad characters from the dvdname
371 dvdname=${dvdname%.} # remove trailing '.' character
372
373 # add the suffix extension to the end of the dvdname
374 dvdname=$dvdname$extension
375
376 # make a "safe" dvdname (remove special characters)
377 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
378
379 # Make sure we have a non-empty dvdname
380 if [ -z "$dvdname" ]; then
381   echo "-E- unable to determine dvdname"
382   exit 1
383 fi
384
385 # make sure our vobfile value is set
386 if [ -z "$vobfile" ]; then
387   vobfile="$dest/$dvdname.VOB"
388 fi
389
390 # set up some variables to hold various logfiles
391 logfile="$logdir/$dvdname.log"
392 passlogfile="$tmpdir/$safedvdname.log"
393 ddrescuelog=`tempfile`
394 dvdauthorlog=`tempfile`
395 encodelog=`tempfile`
396 dumplog=`tempfile`
397
398 # create the tmpdir if it doesn't already exist
399 if [ ! -d "$tmpdir" ]; then
400   mkdir -p "$tmpdir"
401   if [ $? != 0 ]; then
402     echo "-E- Unable to create the tmpdir: $tmpdir"
403     exit 1
404   fi
405 fi
406
407 # create the logdir if it doesn't already exist
408 if [ ! -d "$logdir" ]; then
409   mkdir -p "$logdir"
410   if [ $? != 0 ]; then
411     echo "-E- Unable to create the logdir: $logdir"
412     exit 1
413   fi
414 fi
415
416 ##############################################################################################
417 # cleanup functions
418 ##############################################################################################
419 cleanup() { 
420   if [ $keep_intermediate_files -eq 0 ]; then
421     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
422     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
423     [[ -e "$encodelog" ]] && rm -f "$encodelog"
424     [[ -e "$dumplog" ]] && rm -f "$dumplog"
425   else
426     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
427     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
428     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
429     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
430   fi
431   echo ""
432 }
433
434 fatal_and_exit() {
435   if [[ -z "$1" ]]; then
436     msg="-E- control-c killed us"
437   else
438     msg=$1
439   fi
440   echo -e 2>&1 "$msg" | tee -a "$logfile"
441   if [[ -n "$mailto" ]]; then
442     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
443   fi
444   keep_intermediate_files=1
445   exit 1
446 }
447
448 # Call our cleanup functions on INT and EXIT signals
449 trap fatal_and_exit INT
450 trap cleanup EXIT
451
452 ##############################################################################################
453 # processing functions
454 ##############################################################################################
455
456 # encode the vob file into a compressed file format using handbrake
457 function encode_vob_file_handbrake {
458   
459   # declare some globals
460   typeset handbrake_cli=""
461   typeset handbrake_video_encoder_opts=""
462   typeset filetype=""
463   typeset handbrake_audio_opts=""
464   typeset hb_profile=""
465
466   # Set a variable that we will use later to determine if we found a handler for $profile or not
467   typeset -i found_profile=0    
468
469   # For a given profile, to override the 2 pass behavior to be single pass,
470   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
471   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
472   PASSES="-2"
473
474   # Check the global force_onepass_mode. If it is set, change our variables appropriately
475   # to force 1-pass encoding across all profiles.
476   if [ $force_onepass_mode -eq 1 ]; then
477     PASSES=""
478   fi
479
480   # get our audio track from the VOB file (requires mp4 version of handbrake to extract)
481   get_audio_track_from_vob "$vobfile" "$handbrake_mp4"
482
483   # XVID profile
484   if [[ "$profile" =~ "xvid" ]]; then
485     found_profile=1
486     handbrake_cli="$handbrake_xvid"
487     final_output_file="$dest/$dvdname.avi"
488     filetype="avi"
489
490     # Very High Quality (16fps)
491     if [ "$profile" == "xvidvhq" ]; then
492       handbrake_opts[0]="-f avi"
493       handbrake_opts[1]="-b $target_bitrate"
494       handbrake_opts[2]="-e xvid"
495       handbrake_opts[3]="-T"
496       handbrake_opts[4]="-5"
497       handbrake_opts[5]="-8"
498     fi
499     # High Quality (20fps)
500     if [ "$profile" == "xvidhq" ]; then
501       handbrake_opts[0]="-f avi"
502       handbrake_opts[1]="-b $target_bitrate"
503       handbrake_opts[2]="-e ffmpeg"
504       handbrake_opts[3]="-T"
505       handbrake_opts[4]="-5"
506     fi
507     # Fast (28fps)
508     if [ "$profile" == "xvid" ]; then
509       handbrake_opts[0]="-f avi"
510       handbrake_opts[1]="-b $target_bitrate"
511       handbrake_opts[2]="-e ffmpeg"
512       handbrake_opts[3]="-T"
513     fi
514   fi
515
516   # MP4 profile
517   if [[ "$profile" =~ "mp4" ]]; then
518     found_profile=1
519     handbrake_cli="$handbrake_mp4"
520     final_output_file="$dest/$dvdname.mp4"
521     PASSES=""
522
523     # Very High Quality
524     if [ "$profile" == "mp4vhq" ]; then
525       profile="hb_High_Profile"
526     fi
527     # High Quality
528     if [ "$profile" == "mp4hq" ]; then
529       profile="hb_Normal"
530     fi
531     # Fast
532     if [ "$profile" == "mp4" ]; then
533       profile="hb_Classic"
534     fi
535   fi
536
537   # iphone and ipod MP4 profiles
538   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
539     found_profile=1
540     handbrake_cli="$handbrake_mp4"
541     final_output_file="$dest/$dvdname.mp4"
542     PASSES=""
543
544     # iphone
545     if [ "$profile" == "iphone" ]; then
546       profile="hb_iPhone"
547     fi
548     # ipod
549     if [ "$profile" == "ipod" ]; then
550       profile="hb_iPod"
551     fi
552   fi
553   
554   # Predefined Handbrake Profile Handling
555   if [[ "$profile" =~ "hb" ]]; then
556     found_profile=1
557     handbrake_cli="$handbrake_mp4"
558     final_output_file="$dest/$dvdname.mp4"
559     PASSES=""
560     
561     # extract the HandBrake Profile name from $profile
562     hb_profile=`echo "$profile" | sed 's/hb_//g' | sed 's/_/ /g'`
563   fi
564
565   # Make sure we found a handler for the given profile
566   if [ $found_profile -eq 0 ]; then
567     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
568   fi
569
570   # setup our audio option
571   if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 1 ]; then
572     handbrake_audio_opts="-E faac,ac3 -6 dpl2,auto"
573   fi
574   if [ $audio_6ch -eq 1 ] && [ $audio_2ch -eq 0 ]; then
575     handbrake_audio_opts="-E ac3 -6 auto"
576   fi
577   if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 0 ]; then
578     handbrake_audio_opts="-E faac -6 dpl2"
579   fi
580   if [ -n "$track" ]; then
581     handbrake_audio_opts="$handbrake_audio_opts -a $track"
582   fi
583
584   # Convert our array of opts into a string
585   for OPTS in "${video_encoder_opts[@]}"; do 
586     handbrake_video_encoder_opts="$handbrake_video_encoder_opts:$OPTS"
587   done
588   if [ -n "$handbrake_video_encoder_opts" ]; then
589     handbrake_video_encoder_opts="-x $handbrake_video_encoder_opts"
590   fi
591   for OPTS in "${handbrake_opts[@]}"; do 
592     handbrake_cmd_line_opts="$handbrake_cmd_line_opts $OPTS"
593   done
594   
595   # Execute the handbrake command to encode the video
596   if [ -n "$hb_profile" ]; then
597     echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" -Z \"$hb_profile\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts $PASSES >> $encodelog 2>&1" >> "$logfile"
598     $handbrake_cli -i "$vobfile" -o "$final_output_file" -Z "$hb_profile" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts $PASSES >> $encodelog 2>&1
599     handbrake_retval=$?
600   else 
601     echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts $PASSES >> $encodelog 2>&1" >> "$logfile"
602     $handbrake_cli -i "$vobfile" -o "$final_output_file" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts $PASSES >> $encodelog 2>&1
603     handbrake_retval=$?
604   fi
605   if [ $handbrake_retval != 0 ]; then
606     fatal_and_exit "-E- Unhandled handbrake error"
607   fi
608
609   # Concatenate the encode log to our main log file, greping out unwanted lines
610   cat $encodelog | grep -v "Encoding:" | grep -v "hb_demux_ps" >> "$logfile" 
611   cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | head -1 >> "$logfile"
612   cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | tail -1 >> "$logfile"
613 }
614
615 # encode the vob file into a compressed file format using mencoder
616 function encode_vob_file_mencoder {
617
618   # Set a variable that we will use later to determine if we found a handler for $profile or not
619   typeset -i found_profile=0
620
621   # For a given profile, to override the 2 pass behavior to be single pass,
622   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
623   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
624   PASSES="1 2"
625
626   # Declare our default 2 pass variables
627   passlogfile_opt="-passlogfile $passlogfile"
628   pass_opt="pass=%PASS"
629
630   # Check the global force_onepass_mode. If it is set, change our variables appropriately
631   # to force 1-pass encoding across all profiles.
632   if [ $force_onepass_mode -eq 1 ]; then
633     PASSES="2"
634     passlogfile_opt=""
635     pass_opt=""    
636   fi
637
638   # XVID profile
639   if [[ "$profile" =~ "xvid" ]]; then
640     found_profile=1
641     final_output_file="$dest/$dvdname.avi"
642     mencoder_general_opts="$lang_opts $passlogfile_opt"
643     mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
644     mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
645     mencoder_video_encoder_opts="-ovc xvid -xvidencopts $pass_opt"
646
647     # Very High Quality (16fps)
648     if [ "$profile" == "xvidvhq" ]; then
649       video_encoder_opts[0]="bitrate=$target_bitrate"
650       video_encoder_opts[1]="threads=$mencoder_threads"
651       video_encoder_opts[2]="chroma_opt"
652       video_encoder_opts[3]="vhq=4"
653       video_encoder_opts[4]="bvhq=1"
654       video_encoder_opts[5]="quant_type=mpeg"
655       video_encoder_opts[6]="autoaspect"
656     fi
657     # High Quality (20fps)
658     if [ "$profile" == "xvidhq" ]; then
659       video_encoder_opts[0]="bitrate=$target_bitrate"
660       video_encoder_opts[1]="threads=$mencoder_threads"
661       video_encoder_opts[2]="chroma_opt"
662       video_encoder_opts[3]="vhq=2"
663       video_encoder_opts[4]="bvhq=1"
664       video_encoder_opts[5]="quant_type=mpeg"
665       video_encoder_opts[6]="autoaspect"
666     fi
667     # Fast (28fps)
668     if [ "$profile" == "xvid" ]; then
669       video_encoder_opts[0]="bitrate=$target_bitrate"
670       video_encoder_opts[1]="threads=$mencoder_threads"
671       video_encoder_opts[2]="vhq=0"
672       video_encoder_opts[3]="turbo"
673       video_encoder_opts[4]="autoaspect"
674     fi
675
676     for OPTS in "${video_encoder_opts[@]}"; do 
677       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
678     done
679
680     if [ $audio_2ch -eq 0 ]; then
681       # These options produce good 6 channel audio for linux and windows
682       mencoder_audio_opts="-oac copy"
683       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
684       mencoder_audioch_opts[0]="-channels 6 -af channels=6"
685       mencoder_audioch_opts[1]="-af channels=6"
686       mencoder_audioch_opts[2]=""
687     else
688       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
689       mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
690       mencoder_audioch_opts[0]=""
691     fi
692  
693   fi
694
695   # iphone and ipod MP4 profiles
696   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
697     found_profile=1
698     if [ "$profile" == "iphone" ]; then
699       # SCALE: 480x320
700       # scale width to 480, set height appropriately, but keep a multiple of 16
701       #SCALE=",scale=480:-10"
702       # scale the video down however far is necessary to fit in 480x320
703       SCALE=",dsize=480:320:0,scale=-8:-8"
704     else
705       # SCALE: 320x240
706       # scale width to 320, set height appropriately, but keep a multiple of 16
707       #SCALE=",scale=320:-10"
708       # scale the video down however far is necessary to fit in 320x240
709       SCALE=",dsize=320:240:0,scale=-8:-8"
710     fi
711     final_output_file="$dest/$dvdname.mp4"
712     mencoder_general_opts="$lang_opts $passlogfile_opt"
713     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
714     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
715     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
716     video_encoder_opts[0]="bitrate=$target_bitrate"
717     video_encoder_opts[1]="threads=$mencoder_threads"
718     video_encoder_opts[2]="vbv_maxrate=1500"
719     video_encoder_opts[3]="vbv_bufsize=2000"
720     video_encoder_opts[4]="nocabac"
721     video_encoder_opts[5]="me=umh"
722     video_encoder_opts[6]="subq=6"
723     video_encoder_opts[7]="frameref=6"
724     video_encoder_opts[8]="trellis=1"
725     video_encoder_opts[9]="level_idc=30"
726     video_encoder_opts[10]="global_header"
727     video_encoder_opts[11]="bframes=0"
728     video_encoder_opts[12]="partitions=all"
729     for OPTS in "${video_encoder_opts[@]}"; do 
730       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
731     done
732
733     mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
734     mencoder_audioch_opts[0]="-channels 2 -srate 48000"
735   fi
736
737   if [ $found_profile -eq 0 ]; then
738     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
739   fi
740
741   # Do not edit this line. $mencoder_video_encoder_opts must be last
742   mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
743   mencoder_retval=0
744
745   for PASS in $PASSES
746   do 
747     # Set some options based on which pass we are in
748     mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
749     [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
750     [ $PASS -eq 1 ] && output_file="/dev/null"
751     [ $PASS -eq 2 ] && output_file="$final_output_file"
752   
753     # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
754     for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
755     do
756       echo -e "   Encoding pass $PASS"
757       echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
758       mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
759       mencoder_retval=$? 
760       grep -q "\[channels\] Invalid" $encodelog
761       if [ $? != 0 ]; then          
762         break;
763       else
764         echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
765       fi
766     done
767       
768     if [ $mencoder_retval != 0 ]; then
769       fatal_and_exit "-E- Unhandled mencoder error"
770     fi
771
772     # Concatenate the encode log to our main log file, greping out unwanted lines
773     cat $encodelog | grep -v "^Pos:" | grep -v "duplicate" >> "$logfile"
774
775   done
776 }
777
778 function make_dvd_iso_image {
779
780   isofile="$1"
781
782   # check to see if we have a dvdpath to rip from instead of $dev
783   if [ -z "$dvdpath" ]; then
784     # load the CSS codes in the DVD drive 
785     lsdvd $dev >> "$logfile"
786     if [ $? != 0 ]; then
787       fatal_and_exit "-E- lsdvd $dev failed" 
788     fi
789
790     # read the DVD, ignoring/skipping CRC errors
791     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
792     if [ $? != 0 ]; then
793       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
794     fi
795     cat "$ddrescuelog" >> "$logfile"
796   else
797     # rip from a path instead
798     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
799   fi
800 }
801
802 function make_dvd_iso_image_from_folder {
803   
804   src="$1"
805   dst="$2"
806   handle_error=$3
807   
808   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
809
810   # make an iso image out of our directory
811   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
812   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
813
814   # set the audio languages from the iso if it exists and is non-zero in size
815   if [ -s "$dst" ]; then
816     get_feature_title "$dst"
817     get_audio_id_from_iso "$dst"
818   fi
819
820   # make sure we were able to create the iso image from the folder given to us
821   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
822     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
823     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
824     # remove the bad iso file
825     [[ -e "$dst" ]] && rm -f "$dst"
826     # get the feature title from the DVD folder
827     get_feature_title "$dvdpath"
828     # create our main VOB file from the ISO
829     create_main_vob_with_mplayer "$dvdpath" 
830     # get our audio id from the VOB file
831     get_audio_id_from_vob "$vobfile"
832   fi
833 }
834
835 function make_dvdbackup_folder_image {
836   # extract the feature title from the DVD image
837   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
838   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
839   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
840   if [ $? != 0 ]; then
841     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
842   fi
843 }
844
845 function make_dvdauthor_folder_image {
846   # create a new DVD video of the feature title
847   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
848   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
849   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
850   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
851
852   # There is a chance that dvdauthor won't like some of the VOBs.
853   # We can't tell ahead of time which ones it will choke on. 
854   # So, we need to run it over and over again until it can process
855   # all the VOBs. If it can't handle one of them, run it through
856   # mencoder to fix it and try again. These errors are typically
857   # present due to the copy protection that ddrescue removed.
858   grep -q "SCR moves" $dvdauthorlog
859   while [ $? == 0 ]; do
860     # fix bad vobs that get the "SCR moves backwards" error:
861     #  STAT: Processing VTS_01_0.VOB...
862     #  ERR:  SCR moves backwards, remultiplex input.
863     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
864     if [[ ! -f "$badvob" ]]; then
865       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
866     fi
867     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
868     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
869     mv -f $badvob.fixed $badvob
870     echo "-> Creating DVD video $dest/$dvdname"
871     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
872     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
873     grep -q "SCR moves" $dvdauthorlog
874   done
875 }
876
877 function get_feature_title {
878   source="$1"
879   # if a feature title was given on the command line, use it
880   if [ $feature_title_override -ne 0 ]; then
881     feature_title=$feature_title_override
882     return 0
883   fi
884   # otherwise, use lsdvd to figure it out
885   if [ $ripdvd -eq 1 ]; then
886     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
887   else 
888     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
889   fi
890 }
891
892 function create_main_vob_with_cat {
893   # cd to the feature title DVD folder
894   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
895   if [ $? != 0 ]; then
896     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
897   fi
898
899   # concatenate all the VOBs together into 1 giant VOB
900   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
901   cat $vobs > "$tmpdir/$dvdname.VOB"
902
903   # cd back to the dir we started from
904   popd > /dev/null 2>&1
905 }
906
907 function create_main_vob_with_mplayer {
908
909   # argument processing  
910   source="$1"
911   remove_dumplog=$2
912
913   # make sure we have a valid feature title
914   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
915     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
916   fi
917
918   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
919   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
920     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
921     msg="$msg We also detected another condition that requires us to use dumpstream. "
922     msg="$msg\n    Unable to rip this DVD in the mode you requested."
923     fatal_and_exit "$msg"
924   fi
925
926   # use mplayer to create the main VOB file
927   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
928   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
929   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
930   if [ $? != 0 ]; then
931     cat $dumplog | grep -v "^A:" >> "$logfile"
932     fatal_and_exit "-E- Mplayer Failed"
933   fi
934   cat $dumplog | grep -v "^A:" >> "$logfile"
935   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
936 }
937
938 function get_audio_id_from_iso {
939   # Adjust our audio ID to find the english audio stream
940   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
941   iso="$1"
942   aidcheck=`tempfile`
943   aid=$default_aid
944   alang=$default_alang
945   if [ $aid_override -lt 0 ]; then 
946     mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
947     grep -q "aid: $aid" $aidcheck
948     while [ $? == 1 ] && [ $aid -lt 159 ]; do
949       (( aid = aid + 1 ))
950       grep -q "aid: $aid" $aidcheck
951     done
952     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
953   else
954     aid=$aid_override
955   fi
956   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
957   # mencoder default DVD audio track language selection (english)
958   lang_opts="-aid $aid -alang $alang"
959 }
960
961 function get_crop_from_iso { 
962   FRAMES=10000
963   echo "-> Detecting black frame border crop value from ISO file"
964   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
965   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
966   [[ -e "md5sums" ]] && rm -f "md5sums"
967   CROP=`cat $dumplog | grep CROP | tail -1`
968   echo "   Found crop value of $CROP" >> "$logfile"
969   CROP=${CROP#* crop=}
970   CROP=${CROP%%\).*}
971   typeset -i CROPCHECK
972   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
973   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
974   if [ -z "$CROP" ]; then
975     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
976     return
977   fi
978   if [ $CROPCHECK -lt 0 ]; then 
979     CROP=""
980   else 
981     CROP=",crop=$CROP"
982   fi
983   echo "   Setting mencoder crop filter to: $CROP"
984 }
985
986 function get_crop_from_vob { 
987   FRAMES=10000
988   echo "-> Detecting black frame border crop value from VOB file"
989   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
990   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
991   [[ -e "md5sums" ]] && rm -f "md5sums"
992   CROP=`cat $dumplog | grep CROP | tail -1`
993   echo "   Found crop value of $CROP" >> "$logfile"
994   CROP=${CROP#* crop=}
995   CROP=${CROP%%\).*}
996   typeset -i CROPCHECK
997   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
998   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
999   if [ -z "$CROP" ]; then
1000     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
1001     return
1002   fi
1003   if [ $CROPCHECK -lt 0 ]; then 
1004     CROP=""
1005   else 
1006     CROP=",crop=$CROP"
1007   fi
1008   echo "   Setting mencoder crop filter to: $CROP"
1009 }
1010
1011 function get_audio_track_from_vob {
1012   # Adjust our audio ID to find the english audio stream
1013   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1014   vob="$1"
1015   handbrake_cli="$2"
1016   aidcheck=`tempfile`
1017   aid=$default_aid
1018   alang=$default_alang
1019   if [ $aid_override -lt 0 ]; then 
1020     mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
1021     grep -q "Found audio stream: $aid" $aidcheck
1022     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1023       (( aid = aid + 1 ))
1024       grep -q "Found audio stream: $aid" $aidcheck
1025     done
1026     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1027   else 
1028     aid=$aid_override
1029   fi
1030   # Now that we've found the right audio id, find the corresponding audio track in HandBrake
1031
1032   # convert the aid we found into hex
1033   aid_hex=`echo "obase=16; $aid" | bc`
1034   
1035   # extract the audio streams in the vob
1036   #ffmpeg -i "$vob" > $aidcheck 2>&1
1037   $handbrake_cli --stop-at 0 -i "$vob" -o /dev/null -v 100 > $aidcheck 2>&1
1038   
1039   # find the stream that matches our aid
1040   #stream=`grep "Stream.*\[0x$aid_hex\]" $aidcheck`
1041   stream=`grep "scan: audio" $aidcheck | grep -n "" | grep "scan: audio 0x$aid_hex"`
1042  
1043   # extract the track number that handbrake uses
1044   #track=`expr match "$stream" '.*#[0-9]\.\([0-9]*\)'`
1045   track=`expr match "$stream" '^\([0-9]*\):'`
1046
1047   if [ -n "$track" ]; then   
1048     echo "-> Setting the audio ID to $aid. Setting the audio track to $track." | tee -a "$logfile"
1049   fi
1050 }
1051
1052 function get_audio_id_from_vob {
1053   # Adjust our audio ID to find the english audio stream
1054   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1055   vob="$1"
1056   aidcheck=`tempfile`
1057   aid=$default_aid
1058   alang=$default_alang
1059   if [ $aid_override -lt 0 ]; then 
1060     mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
1061     grep -q "Found audio stream: $aid" $aidcheck
1062     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1063       (( aid = aid + 1 ))
1064       grep -q "Found audio stream: $aid" $aidcheck
1065     done
1066     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1067   else 
1068     aid=$aid_override
1069   fi
1070   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
1071   # mencoder default DVD audio track language selection (english)
1072   lang_opts="-aid $aid -alang $alang"
1073 }
1074
1075 function check_vob_for_corrupted_start {
1076   # check to see if the beginning of the DVD has a form of copy protection
1077   # where they have deliberately broken the first X number of frames of the DVD.
1078   # If we don't skip these, our resulting VOB file will not play.
1079   badvobcheck=`tempfile`
1080   endpos=360
1081   skip=0
1082   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
1083   if [ $? != 0 ]; then
1084     fatal_and_exit "-E- Mencoder Failed"
1085   fi
1086   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
1087   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
1088     (( skip = skip + 5 ))
1089     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
1090     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
1091     if [ $? != 0 ]; then
1092       fatal_and_exit "-E- Mencoder Failed"
1093     fi
1094     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
1095   done
1096   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
1097
1098   # cat the giant VOB into mencoder to create a playable VOB file
1099   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
1100   if [ $? != 0 ]; then
1101     fatal_and_exit "-E- Mencoder Failed"
1102   fi
1103 }
1104
1105 function check_vob_for_completeness {
1106   # check to make sure we got out a complete VOB.
1107   # there is another kind of copy protection where the VOB's may
1108   # have "MPG EOF" frames in the middle of the stream. 
1109   # this causes mencoder to not process the entire VOB, and exit without any errors.
1110   # detect this by seeing how much smaller the dst vob is from the src vob.
1111   MAX_FILESIZE_DELTA_PERCENT=70
1112   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
1113   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
1114   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
1115   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
1116     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
1117     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
1118     create_main_vob_with_mplayer "$isofile"
1119     [[ -e "$dumplog" ]] && rm -f $dumplog
1120     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
1121     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
1122     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
1123       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
1124     fi
1125   fi
1126 }
1127
1128 function check_vob_for_too_many_video_packets {
1129   # If our earlier algorithm to work around this failed, throw an error.
1130   # check to see if this DVD has a protection scheme we don't know how to work around
1131   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
1132   # for some reason, the video is black, while the audio rolls, then the video finally comes
1133   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
1134   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
1135   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
1136   grep -q "Too many video packets in the buffer:" "$logfile"
1137   if [ $? == 0 ]; then
1138     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
1139     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
1140     create_main_vob_with_mplayer "$isofile"
1141     grep -q "Too many video packets in the buffer:" $dumplog
1142     if [ $? == 0 ]; then
1143       [[ -e "$dumplog" ]] && rm -f $dumplog
1144       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
1145     fi
1146     [[ -e "$dumplog" ]] && rm -f $dumplog
1147   fi
1148 }
1149
1150 function check_vob_for_a52_crc_errors {
1151   # Let's see if we can playback our newly created VOB file without any errors.
1152   # if there are issues, let's detect them now, and try to recreate the VOB
1153   # there are some forms of copy protection that have missed above, that evidence
1154   # themselves when we try to playback the VOB file. This was added to deal with
1155   # the "a52: CRC check failed" copy protection scheme.
1156   MAX_ERRORS=10
1157   ENDPOS=120
1158   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
1159   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
1160   cat $dumplog | grep -v "^A:" >> "$logfile"
1161   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
1162   if [ $errors -gt $MAX_ERRORS ]; then
1163     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
1164     create_main_vob_with_mplayer "$isofile"
1165     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
1166     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
1167     if [ $? != 0 ]; then
1168       cat $dumplog | grep -v "^A:" >> "$logfile"
1169       fatal_and_exit "-E- Mplayer Failed"
1170     fi
1171     cat $dumplog | grep -v "^A:" >> "$logfile"
1172     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
1173     if [ $errors -gt $MAX_ERRORS ]; then
1174       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
1175     fi
1176   fi
1177   [[ -e "$dumplog" ]] && rm -f $dumplog
1178 }
1179
1180 function calculate_bitrate_from_target_size {
1181   # determine what our bitrate needs to be if a target size was specified instead
1182   if [ $target_size -ne 0 ]; then
1183     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
1184     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
1185     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
1186   fi
1187 }
1188
1189 function create_dvdauthor_dvd_xml_file {
1190   # make a dvdauthor xml menu file to create a valid DVD video from 
1191   # this script does a good job, but we'll still need to clean it up a bit after it runs
1192   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
1193   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
1194   if [ $? != 0 ]; then
1195     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
1196   fi
1197
1198   # replace the first line of the xml file to remove the bad dest path
1199   awk -v line=1 -v new_content="<dvdauthor>" '{
1200     if (NR == line) {
1201       print new_content;
1202     } else {
1203       print $0;
1204     }
1205   }' dvd.xml > dvd.xml.new
1206   mv -f dvd.xml.new dvd.xml
1207   if [ $? != 0 ]; then
1208     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1209   fi
1210
1211   # remove the "<video " property line from the xml file
1212   cat dvd.xml | grep -v "<video" > dvd.xml.new
1213   mv -f dvd.xml.new dvd.xml
1214   if [ $? != 0 ]; then
1215     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1216   fi
1217   
1218   # remove the extra <pgc>..</pgc> pairs
1219   cat dvd.xml | awk 'BEGIN {x=1}
1220   {
1221     if ($0~"</pgc>") {x=0}
1222     if (x==1) {print $0}
1223     if ($0~"<pgc>") {x=1}
1224   }' > dvd.xml.new
1225   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
1226   mv -f dvd.xml.new dvd.xml
1227   if [ $? != 0 ]; then
1228     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1229   fi
1230
1231   # remove the VTS_*_0.VOB file as this is just the main menu video clip
1232   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
1233   mv -f dvd.xml.new dvd.xml
1234   if [ $? != 0 ]; then
1235     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1236   fi
1237 }
1238
1239 function check_for_mplayer_dumpstream_incompatibility {
1240
1241   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
1242
1243   if [ ! -e "$vobfile" ]; then
1244     # mplayer dumpstream does not work on DVDs that obscure the feature title.
1245     # A DVD that has 99 titles, where the longest title isn't the main feature
1246     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
1247     # out what the feature title is. This script will run through that flow if we
1248     # set use_mplayer_dumpstream to 0. Check for this here.
1249     if [ $ripdvd -eq 1 ]; then
1250       lsdvd $dev | grep -q "Title: 99"
1251     else
1252       lsdvd "$isofile" | grep -q "Title: 99"
1253     fi
1254     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
1255     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
1256       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
1257         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
1258         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1259         echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
1260         invalid_feature_title=1
1261       else 
1262         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
1263         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
1264         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1265         use_mplayer_dumpstream=0
1266         invalid_feature_title=1
1267       fi
1268       return
1269     fi
1270   fi
1271
1272   # There is another form of protection that causes the mplayer dumpstream to fail. 
1273   # This can be detected by telling mplayer to parse the VOB file by copying its audio
1274   # video streams to a dummy output file (/dev/null). Do that here to check for that 
1275   # problem before continuing.
1276   if [ -e "$vobfile" ]; then
1277     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
1278     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
1279     grep -q "Too many audio packets in the buffer" $dumplog
1280     if [ $? == 0 ]; then
1281       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
1282       use_mplayer_dumpstream=0
1283       mplayer_dumpstream_incompatibility=1
1284     fi
1285     [[ -e "$dumplog" ]] && rm -f $dumplog
1286   fi
1287 }
1288
1289 function fill_mythvideo_metadata {
1290
1291   # This function must be passed the filename as an argument
1292   # The filename must be a full path to the file
1293   filename="$1"
1294
1295   # Make sure the fill mythvideo metadata option has been set to 1
1296   if [ $fill_mythvideo_metadata -eq 0 ]; then
1297     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
1298     return 0
1299   fi
1300
1301   # If the fill mythvideo metadata script is present, run it
1302   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
1303   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
1304     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
1305     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
1306   else
1307     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
1308     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
1309   fi
1310 }
1311
1312 # remove the intermediate VOB file
1313 function remove_intermediate_vob_file {
1314   if [ $keep_intermediate_files -eq 0 ]; then
1315     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
1316   else
1317     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
1318   fi
1319 }
1320
1321 # remove the original DVD image 
1322 function remove_intermediate_iso_file {
1323   [[ $keep_isofile -eq 1 ]] && return 1
1324   if [ $keep_intermediate_files -eq 0 ]; then
1325     [[ -e "$isofile" ]] && rm "$isofile"
1326   else
1327     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
1328   fi
1329 }
1330
1331 # remove the intermediate dvdbackup folder
1332 function remove_intermediate_dvdbackup_folder {
1333   if [ $keep_intermediate_files -eq 0 ]; then
1334     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
1335   else
1336     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
1337   fi
1338 }
1339
1340 ##############################################################################################
1341 # MAIN
1342 ##############################################################################################
1343
1344 # Make a note of when this DVD rip started
1345 date=`date`
1346 echo -e "\n$date DVD rip started" >> "$logfile"
1347 echo "$cmd" >> "$logfile"
1348
1349 # Rip the DVD - Mirror Mode
1350 if [ $mirror_mode -eq 1 ]; then
1351   echo "-> Ripping DVD $dvdname to $dest"
1352
1353   # use ddrescue to make an ISO image of the disk
1354   make_dvd_iso_image "$dest/$dvdname.iso"
1355
1356   # add this video data to the mythtv DB
1357   fill_mythvideo_metadata "$dest/$dvdname.iso" 
1358
1359   # eject the disk upon completion
1360   if [ $eject_disk -ne 0 ]; then
1361     eject -T $dev
1362   fi
1363
1364   date=`date`
1365   echo "$date DVD rip completed" | tee -a "$logfile"
1366
1367   if [[ -n "$mailto" ]]; then
1368     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1369   fi
1370
1371 fi
1372
1373 # Rip the DVD - Main Title Feature Only
1374 if [ $mirror_mode -eq 0 ]; then
1375
1376   # Rip image from DVD
1377   if [ $ripdvd -eq 1 ]; then
1378     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1379     # use ddrescue to make an ISO image of the disk
1380     make_dvd_iso_image "$tmpdir/$dvdname.iso"
1381   fi
1382
1383   # Rip image from DVD path
1384   if [ -n "$dvdpath" ]; then
1385     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1386     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1387   fi
1388
1389   # make sure our isofile value is set
1390   if [ -z "$isofile" ]; then
1391     isofile="$tmpdir/$dvdname.iso"
1392   fi
1393      
1394   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1395
1396     if [ ! -e "$vobfile" ]; then
1397       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1398       
1399       # get the feature title from the ISO
1400       get_feature_title "$isofile"
1401  
1402       # get the crop value from the ISO
1403       get_crop_from_iso
1404
1405       # check for mplayer dumpstream incompatibilities
1406       # if they exist, this method will set this mode to 0.
1407       check_for_mplayer_dumpstream_incompatibility
1408
1409       if [ $use_mplayer_dumpstream -eq 1 ]; then 
1410
1411         # get our audio id from the ISO file
1412         get_audio_id_from_iso "$isofile"
1413
1414         # create our main VOB file from the ISO
1415         create_main_vob_with_mplayer "$isofile"
1416      
1417         # remove the intermediate VOB file
1418         remove_intermediate_vob_file
1419
1420         # it's possible that our VOB is still corrupted in some manner
1421         # check to make sure it is still a good VOB before continuing.
1422         check_for_mplayer_dumpstream_incompatibility
1423
1424       fi
1425  
1426       if [ $use_mplayer_dumpstream -eq 0 ]; then 
1427
1428         # use dvdbackup to make a DVD folder of the feature title
1429         make_dvdbackup_folder_image
1430   
1431         # create our main VOB file
1432         create_main_vob_with_cat
1433
1434         # get our audio id from the VOB file
1435         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1436   
1437         # check for corrupted VOB start
1438         check_vob_for_corrupted_start
1439  
1440         # check to make sure our VOB is complete
1441         check_vob_for_completeness
1442
1443         # check to make sure our VOB doesn't have too many video packets
1444         check_vob_for_too_many_video_packets
1445
1446         # check to make sure our VOB doesn't have a52 crc errors
1447         check_vob_for_a52_crc_errors
1448
1449         # remove the intermediate VOB file
1450         remove_intermediate_vob_file
1451
1452       fi
1453
1454       # remove the intermediate ISO file
1455       remove_intermediate_iso_file
1456
1457     else
1458       if [ "$encoder" != "handbrake" ]; then 
1459         echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1460         # get our audio id from the VOB file
1461         get_audio_id_from_vob "$vobfile"
1462         # get the crop value from the VOB
1463         get_crop_from_vob
1464       fi
1465     fi
1466
1467     # eject the DVD disk since we are finished with it
1468     [ $eject_disk -eq 2 ] && eject -T $dev
1469
1470     # encode the VOB file to a compressed file format
1471     if [ $make_final_dest_comp -eq 1 ]; then
1472       echo "-> Encoding the DVD video to a compressed file using $encoder" | tee -a "$logfile"
1473
1474       # determine what our bitrate needs to be if a target size was specified instead
1475       calculate_bitrate_from_target_size        
1476      
1477       # encode the vob file into a compressed file format
1478       if [[ "$encoder" == "mencoder" ]]; then 
1479         encode_vob_file_mencoder
1480       fi
1481       if [[ "$encoder" == "handbrake" ]]; then
1482         encode_vob_file_handbrake
1483       fi
1484
1485       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1486         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1487         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1488       else
1489         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1490         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1491       fi
1492     fi
1493
1494   # add this video data to the mythtv DB
1495   [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file" 
1496   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
1497     
1498   else
1499
1500   # use dvdbackup to make a DVD folder of the feature title
1501   make_dvdbackup_folder_image
1502
1503   # cd to the feature title DVD folder
1504   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1505   if [ $? != 0 ]; then
1506     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1507   fi
1508   
1509   # create the dvd.xml file for dvdauthor
1510   create_dvdauthor_dvd_xml_file  
1511
1512   # make the final DVD folder image
1513   make_dvdauthor_folder_image
1514
1515   # add this video data to the mythtv DB
1516   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1517  
1518   # cd back to the dir we started from
1519   popd > /dev/null 2>&1
1520
1521   if [ $make_final_dest_iso -eq 1 ]; then
1522
1523     # make an iso image out of our directory
1524     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1525    
1526     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1527     if [ -s "$dest/$dvdname.iso" ]; then
1528       if [ $make_final_dest_folder -eq 0 ]; then
1529         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1530         # remove the folder of the DVD image now that we have a .iso version of it
1531         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1532       fi
1533     else
1534       # we created an empty iso file, remove it
1535       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1536       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1537       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1538     fi
1539  
1540     # add this video data to the mythtv DB
1541     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1542
1543   fi
1544
1545   fi
1546
1547   # remove the ddrescue DVD ISO image
1548   remove_intermediate_iso_file
1549
1550   # remove the tmp dvdbackup folder of the DVD image
1551   remove_intermediate_dvdbackup_folder
1552
1553   # eject the DVD disk upon completion
1554   [ $eject_disk -eq 1 ] && eject -T $dev
1555
1556   date=`date`
1557   echo "$date DVD rip completed" | tee -a "$logfile"
1558
1559   if [[ -n "$mailto" ]]; then
1560     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1561   fi
1562
1563 fi
1564
1565 ##############################################################################################